-module(aoc01).

-export([calculate_module/1, fuel/2, run/0, run2/0]).

all_lines(Path) ->
    {ok, Fd} = file:open(Path, read),
    Lines = all_lines(Fd, []),
    file:close(Fd),
    lists:reverse(Lines).

all_lines(Fd, Lines) ->
    case file:read_line(Fd) of
      {ok, Line} ->
	  all_lines(Fd, [string:chomp(Line) | Lines]);
      eof -> Lines
    end.

calculate_module(Mass) -> math:floor(Mass / 3) - 2.

fuel(Mass, Total) when Mass =< 6 -> Total;
fuel(Mass, Total) -> 
  Fuel = math:floor(Mass / 3) - 2,
  fuel(Fuel, Total + Fuel).

run() ->
    Lines = all_lines("aoc01.txt"),
    FuelQuantities = [calculate_module(list_to_integer(X))
		      || X <- Lines],
    lists:sum(FuelQuantities).

run2() ->
    Lines = all_lines("aoc01.txt"),
    FuelQuantities = [fuel(list_to_integer(X), 0)
		      || X <- Lines],
    lists:sum(FuelQuantities).
