package day1;

object Move extends Enumeration {
  type Move = Value
  val X, O = Value
  val ? = Value("?")
}

object TicTacToe extends App{

    println(winner(List(
      Move.?, Move.?, Move.?,
      Move.?, Move.?, Move.?,
      Move.?, Move.?, Move.?,
    )))

    println(winner(List(
      Move.X, Move.O, Move.O,
      Move.O, Move.X, Move.O,
      Move.?, Move.?, Move.O,
    )))

    println(winner(List(
      Move.X, Move.X, Move.X,
      Move.O, Move.X, Move.O,
      Move.?, Move.?, Move.O,
    )))

    println(winner(List(
      Move.?, Move.X, Move.X,
      Move.O, Move.X, Move.O,
      Move.?, Move.?, Move.O
    )))


def winner(board: List[Move.Move]): Move.Move = {
  val a1 :: a2 :: a3 :: b1 :: b2 :: b3 :: c1 :: c2 :: c3 :: _ = board

  List(
    (a1, a2, a3),
    (b1, b2, b3),
    (c1, c2, c3),
    (a1, b1, c1),
    (a2, b2, c2),
    (a3, b3, c3),
    (a1, b2, c3),
    (a3, b2, c1),
  ).find((rule) => {
    rule._1 == rule._2 && rule._1 == rule._3
  }).map(_._1)
    .getOrElse(Move.?)

}
}
