package day2
import java.util.Properties
import scala.collection.JavaConverters._
import scala.io.Source
import scala.util.Using

trait Censor {
  val substitutions : Map[String, String]
  val source : String
  override def toString(): String = {
    source
      .split(" ")
      .map((word) => substitutions.getOrElse(word, word))
      .mkString(" ")
  }
}

object CensorRun extends App {
  val chars = new Censor {
    val substitutions = Map(
      "shoot" -> "pucky",
      "darn" -> "beans",
    )
    val source = "shoot that darn truck"
  }
  println(chars)
}

object CensorFromFile extends App {
  val loadedSubstitutions = Using.Manager {use =>
    val props = new Properties()
    val input = use(Source.fromResource("alternatives.properties").reader())
    props.load(input)

    props.asScala.toMap
  }.getOrElse(Map())
  
  val chars = new Censor {
    val substitutions = loadedSubstitutions
    val source = "That stupid vermin did it again"
  }
  println(chars)
}